<!--
A component for creating a a list of tags.

Used when creating a competition.
-->
<template>
  <div id="tag-list-creator">
    <b-form-input
        id="tag_list_input"
        style="max-width: 250px; float: left; margin-right: 10px"
        class="space-top" 
        placeholder="Enter tag..."
        v-on:keyup.enter.native="addTag"
        v-model="newTagText"/>
    
    <tag-list :inline="true" :tags="this.tags"/>

  </div>
</template>
<script>
import Tag from '@/models/Tag'
import TagList from '@/components/TagList'

export default {
    name: 'tag-list-creator',

    props: ['value'],

    components: {
        TagList: TagList
    },

    data: function() {
        return {
            newTagText: '',
            tags: this.value
        }
    },
    methods: {
        /**
         * Function called when the user types in a tag and presses
         * enter. Must mutate this component's model.
         */
        addTag: function() {
            var newTag = Tag.create(this.newTagText)
            this.newTagText = ''

            if (!newTag) {
                return
            }

            for (var i = 0; i < this.tags.length; i++) {
                if (this.tags[i].getText() == newTag.getText()) {
                    return
                }
            }

            this.tags.push(newTag)

            // Emit in order to communicate to the container that
            // this value has changed now.
            this.$emit('input', this.value)
        }
    }
    
}
</script>
<style scoped>

</style>
